# 104. Maximum Depth of Binary Tree

# Given the root of a binary tree, return its maximum depth.
# A binary tree's maximum depth is the number of nodes along the longest path from the root node down to the farthest leaf node.

 
# Example 1:

# Input: root = [3,9,20,null,null,15,7]
# Output: 3

# Example 2:

# Input: root = [1,null,2]
# Output: 2
 
# Constraints:

# The number of nodes in the tree is in the range [0, 104].
# -100 <= Node.val <= 100


class TreeNode:
    def __init__(self, val=0, left=None, right=None):
        self.val = val
        self.left = left
        self.right = right

class Solution:
    def depthSearch(self, root, depth):
        if not root: return 0

        max_depth = [depth]
        if root.left:
            max_depth.append(self.depthSearch(root.left, depth+1))
        if root.right:
            max_depth.append(self.depthSearch(root.right, depth+1))

        return max(max_depth)
    
    def maxDepth(self, root: TreeNode) -> int:
        return self.depthSearch(root, 1)